// Breakout // // 28/02/2007
// Steph Thirion - Game Mod workshop: < http://trsp.net/teaching/gamemod >
// 
// english version :)
// made with Processing 0124 Beta

// Modified by Burt du Preez 02/06/2014

public class GameFrame {
int frameOffsetY = 0;
int frameOffsetX = 0;
//

color gameFrameStroke = #FFFFFF;
boolean gameFrameHasStroke = true;
color gameFrameFill = #000000;
int opacityOfRefresh = 255;
boolean gameFrameRefreshes = true;

color backgroundColor = #303030;
boolean backgroundRefreshes = false;

Rectangle gameFrame;
Brick[][] bricks;
Ball[] balls;
PImage[] fBuilding;

int buildings = 0;
int numOfBalls =0;
int maxBalls = 25;

int setColor = 2;

boolean isMineFrame = false;

// SETUP FUNCTION --
 GameFrame(int X, int Y, int maxBalls,PImage[] fBuilding) {
    this.fBuilding= fBuilding;
  frameOffsetY = Y;
  frameOffsetX = X;
  gameFrame = new Rectangle(gameFrameWidth, gameFrameHeight, gameFrameHasStroke, gameFrameStroke, true, gameFrameFill);
  gameFrame.opacity = opacityOfRefresh;
  gameFrame.setPosition(frameOffsetX,frameOffsetY);
  this.maxBalls = maxBalls;
  bricks = new Brick[3][];
  balls = new Ball[maxBalls];
  
 setColor = 2;
 this.isMineFrame = isMineFrame;

}

// DRAW FUNCTION --
void refresh() {
  if(!(buildings < 3))
  refreshScreen();

}

void createBalls(){
  // BALL(S) PROPERTIES --
  int yBalls = 430;

    if(numOfBalls < maxBalls){
    int x = 70+frameOffsetX;
    balls[numOfBalls++] = new Ball(x, yBalls,frameOffsetX,frameOffsetY,bricks,fBuilding,setColor);
    }
}

void createBricks(int sizeY){
  // BRICK GROUP PROPERTIES --
  int set = buildings++;
  int bricksPerRow = barW;
  int numberOfBricks = sizeY*bricksPerRow;
  int brickWidth = 1;
  int brickHeight = 1;
  boolean brickHasStroke = false;
  color brickStroke = #ffffff;
  boolean brickHasFill = false;
  color brickFill = #ff0000;
  int yBricks = 370; 
  color[] rowsColors = {#ff00ff, #ff0000, #ff9900, #ffff00, #00ff00, #00ffff};

  // CREATE BRICKS --
  bricks[set] = new Brick[numberOfBricks];
  for (int i=0; i<numberOfBricks; i++){
    int rowNum = i/bricksPerRow;
    int x = brickWidth*i+frameOffsetX+115+set*50;
    x -= rowNum*bricksPerRow*brickWidth;
    int y = yBricks-i/bricksPerRow*brickHeight+frameOffsetY+15;
    // color
    int num = min(rowNum, rowsColors.length-1);
    color rowColor = rowsColors[num];
    // create brick
  
    bricks[set][i] = new Brick(x, y, brickWidth, brickHeight, brickHasStroke, brickStroke, brickHasFill, rowColor);
  }
  
}

void refreshScreen() {
  // BRICKS
for(int s = 0; s < 3;s++)
  for (int i=0; i<bricks[s].length; i++){
    bricks[s][i].refresh();
  }
  
  // BALLS
  for (int i=0; i<balls.length; i++){
    if(balls[i] != null)
    balls[i].refresh();
  }
}





  
}    
   

